Imports System.IO

Module Module1

     Public Sub Main()

        Dim strSeqEmpFileName As String
        Dim strBinEmpFileName As String
        Dim intSeqEmpFileNbr As Integer

        Dim intRecordCount As Integer

        Dim strEmpName As String
        Dim intDeptNbr As Integer
        Dim strJobTitle As String
        Dim dtmHireDate As Date
        Dim sngHrlyRate As Single

        strSeqEmpFileName = My.Application.Info.DirectoryPath & "\EMPLOYEE.txt"
        strBinEmpFileName = My.Application.Info.DirectoryPath & "\EMPLOYEE.BIN"

        '-----------------------------------------------------------------------
        ' In the first part of this sample program, we will create, or load,
        ' a binary access version of the comma-delimited sequential employee
        ' file that was used in one of the sample programs for sequential access
        ' files.
        '-----------------------------------------------------------------------

        ' Open the sequential employee file for input ...
        intSeqEmpFileNbr = FreeFile()
        FileOpen(intSeqEmpFileNbr, strSeqEmpFileName, OpenMode.Input)

        ' If the binary employee file we want to write already exists,
        ' delete it ...
        If File.Exists(strBinEmpFileName) Then
            File.Delete(strBinEmpFileName)
        End If

        ' Open the binary employee file for writing ...

        Dim objFS As New FileStream(strBinEmpFileName, FileMode.Create, FileAccess.Write)
        Dim objBW As New BinaryWriter(objFS)

        ' Initialize record count variable to keep track of how many records will
        ' be written to the binary file ...
        intRecordCount = 0

        ' This loop will read a record from the comma-delimited sequential employee file
        ' and write a corresponding record to its binary access counterpart ...
        Do Until EOF(intSeqEmpFileNbr)
            ' Read a record's worth of fields from the comma-delimited employee file,
            ' storing the fields into their corresponding variables ...
            Input(intSeqEmpFileNbr, strEmpName)
            Input(intSeqEmpFileNbr, intDeptNbr)
            Input(intSeqEmpFileNbr, strJobTitle)
            Input(intSeqEmpFileNbr, dtmHireDate)
            Input(intSeqEmpFileNbr, sngHrlyRate)
            ' Write a record to the binary file (one field at a time)
            objBW.Write(strEmpName)
            objBW.Write(intDeptNbr)
            objBW.Write(strJobTitle)
            objBW.Write(dtmHireDate.ToBinary)
            objBW.Write(sngHrlyRate)
            ' Increment the record count variable ...
            intRecordCount = intRecordCount + 1
        Loop

        ' Close the sequential file and the binary file ...
        FileClose(intSeqEmpFileNbr)
        objBW.Close()
        objFS.Close()

        '-----------------------------------------------------------------------
        ' In the next part of this sample program, we will display the records
        ' written to the binary file by reading them back and outputting their
        ' contents to the console one by one.
        '-----------------------------------------------------------------------

        ' Print headings ...
        Console.WriteLine("{0} employee records were written to the binary file.", intRecordCount)
        Console.WriteLine()
        Console.WriteLine("Contents as follows:")
        Console.WriteLine()

        Console.WriteLine("EMP NAME".PadRight(20) & " " & _
                          "DEPT".PadRight(4) & " " & _
                          "JOB TITLE".PadRight(25) & " " & _
                          "HIRE DATE".PadRight(10) & " " & _
                          "HRLY RATE".PadRight(7))

        Console.WriteLine("--------".PadRight(20) & " " & _
                          "----".PadRight(4) & " " & _
                          "---------".PadRight(25) & " " & _
                          "---------".PadRight(10) & " " & _
                          "---------".PadRight(7))

        ' Open the binary file for reading ...
        objFS = New FileStream(strBinEmpFileName, FileMode.OpenOrCreate, FileAccess.Read)
        Dim objBR As New BinaryReader(objFS)

        ' Loop thru the binary file to get one "record's worth" of fields
        ' and display each record (the fields) on a console line in each pass of the loop
        Do While objBR.PeekChar <> -1
            strEmpName = objBR.ReadString
            intDeptNbr = objBR.ReadInt32
            strJobTitle = objBR.ReadString
            dtmHireDate = Date.FromBinary(objBR.ReadInt64)
            sngHrlyRate = objBR.ReadSingle
            Console.WriteLine(strEmpName.PadRight(20) & " " & _
                              intDeptNbr.ToString.PadLeft(4) & " " & _
                              strJobTitle.PadRight(25) & " " & _
                              Format(dtmHireDate, "MM/dd/yyyy").PadRight(10) & " " & _
                              Format(sngHrlyRate, "Standard").PadLeft(7))

        Loop

        Console.WriteLine()

        ' Close the binary file ...
        objBR.Close()
        objFS.Close()

        Console.ReadLine()

    End Sub

End Module